## exifprobe 2.0.1

=== DESCRIPTION ===
Exifprobe reads image files produced by digital cameras (including
several so-called "raw" file formats) and reports the structure of
the files and the auxilliary data and metadata contained within them.
In addition to TIFF, JPEG, and EXIF, the program understands several
formats which may contain "raw" camera data, including MRW, CIFF/CRW,
JP2/JPEG2000, RAF, and X3F, as well as most most TIFF-derived "raw"
formats, including DNG, ORF, CR2, NEF, K25/KDC/DCR, and PEF.

MakerNote sections found in Exif IFDs are reported and expanded if the  
note is in a semblance of TIFF IFD format. Information which has been   
published on the internet is used to interpret notes where possible.    

The default output attempts to describe the structure of the file,      
showing location, size and content of auxilliary data, metadata, and    
image sections. Multiple images contained in a single file are noted    
(and JPEG sub-image markers examined for useful data). A summary of     
images found is printed at the end of output for each file.

Many options are provided for detail control of output format.          
For convenience, two pre-set formats (in addition to the default        
'structural' format) are provided: a "report" format (which shows       
"structure" of TIFF ifds, but with values printed inline), and a        
"list" format which eliminates structural elements and presents data    
in a human (or script) readable format for possible use in gallery      
applications.

=== Makefile ===
# @(#) $Id: Makefile,v 1.33 2005/07/25 19:41:06 alex Exp $
# Makefile for EXIFPROBE image file probe

# Any compiler should do
CC=cc
CFLAGS=-DCOLOR -O 

# You probably don't need these
# CFLAGS=-DCOLOR -g -O -Dlint -Wall  -Wno-long-long 
# SPLINTCFLAGS=-DCOLOR -Dlint -showsummary

# If your system has strcasestr(3) you can use this if you like.
# If not defined a fake routine is used (which should be good enough,
# this is used only for the -C option)
# CFLAGS+=-DSTRCASESTR=strcasestr

#Solaris; cultural differences
#CFLAGS += -Du_int32_t=uint32_t

# You'll need this on big-endian machines if (and ONLY if) "byteorder.h"
# is not created properly on first invocation.
#CFLAGS += -DNATIVE_BYTEORDER_BIGENDIAN     # or add to ./byteorder.h

# On Solaris, you may need to use 'gmake', or edit the next line.
PREFIX ?= /usr/local
BINDIR=$(PREFIX)/bin
MANDIR=$(PREFIX)/man/man1


INCLUDES=defs.h extern.h misc.h tifftags.h exiftags.h \
	tiffeptags.h jpegtags.h global.h

MAKERSRCS=maker_nikon.c maker_epson.c maker_olympus.c maker_fujifilm.c \
	maker_casio.c maker_minolta.c maker_sanyo.c maker_canon.c \
    maker_leica.c maker_agfa.c maker_asahi.c maker_panasonic.c \
    maker_kyocera.c maker_toshiba.c maker_sigma.c maker_sony.c \
    maker_konica.c maker_hp.c maker_kodak.c maker_ricoh.c \
    maker_traveler.c

MAKEROBJS=maker_nikon.o maker_epson.o maker_olympus.o maker_fujifilm.o \
	maker_casio.o maker_minolta.o maker_sanyo.o maker_canon.o \
    maker_leica.o maker_agfa.o maker_asahi.o maker_panasonic.o \
    maker_kyocera.o maker_toshiba.o maker_sigma.o maker_sony.o \
    maker_konica.o maker_hp.o maker_kodak.o maker_ricoh.o \
    maker_traveler.o

SRCS=main.c readfile.c print.c tagnames.c process.c misc.c interpret.c \
	print_maker.c maker_generic.c maker_tagnames.c options.c ciff.c\
    jp2000.c mrw.c raf.c x3f.c \
	$(MAKERSRCS)

OBJS=main.o readfile.o print.o tagnames.o process.o misc.o interpret.o \
	print_maker.o maker_generic.o maker_tagnames.o options.o ciff.o \
    jp2000.o mrw.o veclib.o raf.o x3f.o \
	$(MAKEROBJS)

all: byteorder.h exifprobe

byteorder.h:
	@echo -n "Creating byteorder.h: "
	@sh makebyteorder.sh
	@cat byteorder.h
	@echo 

veclib.o: lib/veclib.c
	$(CC) -o veclib.o -c $(CFLAGS) lib/veclib.c

# Need the math library to calculate some APEX things...
exifprobe: $(OBJS) $(INCLUDES) Makefile
	./mkcomptime > comptime.c
	$(CC) -o exifprobe $(CFLAGS) $(OBJS) comptime.c -lm

install: all
	cp exifprobe $(BINDIR)
	cp exifgrep $(BINDIR)
	cp exifprobe.1 $(MANDIR)
	cp exifgrep.1 $(MANDIR)

# if you want HTML man pages, pick a target; I prefer man2html
rman: exifprobe.1 exifgrep.1
    # edit at <blockquote> & APP0...APPn; rman gets it wrong
	rman -f HTML exifprobe.1 > exifprobe-rman.html
	rman -f HTML exifgrep.1 > exifgrep-rman.html

man: exifprobe.1 exifgrep.1
	groff -man -Thtml exifprobe.1 > exifprobe-man.html
	groff -man -Thtml exifgrep.1 > exifgrep-man.html

man2html:
	nroff -man exifprobe.1 | man2html -pgsize 1024 -topm 0 -botm 2 -noheads > exifprobe.1.html
	nroff -man exifgrep.1 | man2html -pgsize 1024 -topm 0 -botm 2 -noheads > exifgrep.1.html

clean:
	rm -f exifprobe *.o comptime.c

distclean: clean undepend
	rm -f byteorder.h MANIFEST.* Makefile.bak exifprobe-*.tar.gz

depend: byteorder.h
	makedepend -- $(CFLAGS) -- $(SRCS)

undepend:
	makedepend

splint: $(SRCS) $(INCLUDES) Makefile
	splint $(SPLINTCFLAGS) $(SRCS)

# DO NOT DELETE THIS LINE -- make depend depends on it.

=== debian/changelog ===
exifprobe (2.0.1-6fakesync1) wily-proposed; urgency=medium

  * Fake sync due to mismatching orig tarball.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Jun 2015 12:01:17 +0100

exifprobe (2.0.1-6) unstable; urgency=medium

  * Upload to unstable.
  * debian/control: added the Homepage field.
  * debian/patches/fix-issues-found-by-afl: added to fix some issues detected
      by AFL. (Closes: #779525, #779527)
  * debian/watch: pointing to new upstream site.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 28 May 2015 18:58:35 -0300

exifprobe (2.0.1-5) experimental; urgency=medium

  * debian/copyright: updated the packaging copyright years.
  * debian/patches/fix-embed-build-time: created to fix an issue while building.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 26 Feb 2015 13:24:54 -0300

exifprobe (2.0.1-4) experimental; urgency=medium

  * debian/control:
      - Improved the long description.
      - Removed the erroneous homepage. Currently, the program
        hasn't a homepage.
  * debian/copyright: removed the erroneous homepage from
      Source field. Currently, the program hasn't a homepage.
  * debian/watch: updated to use a fake site.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 29 Oct 2014 15:36:45 -0200

exifprobe (2.0.1-3) unstable; urgency=medium

  * New maintainer and co-maintainer. Thanks a lot to Martin Albisetti,
      the initial maintainer, for your nice work over this package.
      (Closes: #738911)
  * Migrations:
      - Copyright to 1.0 format.
      - Debian format from 1.0 to 3.0.
      - debian/rules to new (reduced) format.
  * debian/control:
      - Added the Vcs-* fields to control the Debian packaging.
      - Added 'xutils-dev' to Build-Depends field.
      - Added the Homepage field.
      - Bumped Standards-Version to 3.9.6.
      - Removed the reference to upstream homepage from long description.
      - Removed the duplicated 'most' word. Thanks to Aputsiaq Janussen
        <aj@isit.gl>. (Closes: #641179)
      - Updated the short and long description.
  * debian/dirs: useless. Removed.
  * debian/docs:
      - Moved CHANGES_2.0 to new debian/exifprobe.changelog file.
      - Removed the LICENSE.EXIFPROBE file.
  * debian/patches/:
      - Added the 'add_byteorder' and 'Makefile' patches to replace the
        direct changes made in upstream code in past.
      - Added the 'fix_manpages' and 'fix_spelling_error' patches.
      - Added the 'fix-exifgrep' patch. Thanks a lot to Daniel Friesel
        <derf@chaosdorf.de>. (Closes: #597123)
  * debian/rules: set a special target to install the upstream changelog.
      (Closes: #670994)
  * debian/watch: added. (Closes: #462040)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 27 Oct 2014 09:29:00 -0200

exifprobe (2.0.1-2) unstable; urgency=medium

  * QA upload.
  * Updated the DH from 5 to 9.
  * debian/control:
      - Set Debian QA Group as maintainer (see #738911).
      - Updated the Standards-Version from 3.7.2 to 3.9.5.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 23 Aug 2014 23:49:45 -0300

exifprobe (2.0.1-1) unstable; urgency=low

  * Initial release (Closes: #428748)
  * Fixed Makefile and emailed changes upstream

 -- Martin Albisetti <argentina@gmail.com>  Wed, 13 Jun 2007 16:31:10 +0100

=== debian/control ===
Source: exifprobe
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Forensics <forensics-devel@lists.alioth.debian.org>
Uploaders: Joao Eriberto Mota Filho <eriberto@debian.org>
Build-Depends: debhelper (>= 9), xutils-dev
Standards-Version: 3.9.6
Homepage: https://github.com/hfiguiere/exifprobe
Vcs-Browser: http://anonscm.debian.org/cgit/forensics/exifprobe.git
Vcs-Git: git://anonscm.debian.org/forensics/exifprobe.git

Package: exifprobe
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: read metadata from digital pictures
 Exifprobe reads image files produced by digital cameras (including
 several so-called "raw" file formats) and reports the structure of
 the files and the auxiliary data and metadata contained within them.
 .
 In addition to TIFF, JPEG and EXIF, the program understands several
 formats which may contain "raw" camera data, including MRW, CIFF/CRW,
 JP2/JPEG2000, RAF, and X3F, as well as most TIFF-derived "raw" formats,
 including DNG, ORF, CR2, NEF, K25/KDC/DCR and PEF.
 .
 This program is useful in forensics investigations.

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs CHANGES_2.0

=== debian/watch ===
version=3
https://github.com/hfiguiere/exifprobe/releases .*/archive/v?(\d\S+)\.tar\.(?:bz2|gz|xz)

## exifprobe 2.0.1+git20170416.3c2b769

=== Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 # Makefile for EXIFPROBE image file probe
 
 # Any compiler should do
-CC=cc
-CFLAGS=-DCOLOR -O 
+CC?=cc
+CFLAGS=-DCOLOR -O -std=c99
 
 # You probably don't need these
 # CFLAGS=-DCOLOR -g -O -Dlint -Wall  -Wno-long-long

=== debian/changelog ===
exifprobe (2.0.1+git20170416.3c2b769-5) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields:
      Bug-Database, Bug-Submit, Repository, Repository-Browse.
  * Update standards version to 4.5.0, no changes needed.

  [ Giovani Augusto Ferreira ]
  * Bumped DH level to 13.
  * Bumped standards version to 4.5.1, no changes needed.
  * debian/copyright: updated packaging copyright years.

  [ Samuel Henrique ]
  * Configure git-buildpackage for Debian

 -- Giovani Augusto Ferreira <giovani@debian.org>  Mon, 01 Feb 2021 19:32:35 -0300

exifprobe (2.0.1+git20170416.3c2b769-4) unstable; urgency=medium

  [ Giovani Augusto Ferreira ]
  * Using new DH level format. Consequently:
      - debian/compat: removed.
      - debian/control: Changed from 'debhelper' to 'debhelper-compat' in
        Build-Depends field.
  * debian/control:
      - Added the field Rules-Requires-Root: binary-targets.
      - Standards-Version: bumped to 4.4.1 (no changes needed)
  * debian/copyright:
      - Updated years and rights.
  * wrap-and-sort -sa

  [ Samuel Henrique ]
  * Add salsa-ci.yml

 -- Giovani Augusto Ferreira <giovani@debian.org>  Thu, 26 Dec 2019 22:02:51 -0300

exifprobe (2.0.1+git20170416.3c2b769-3) unstable; urgency=medium

  * Bumped DH level to 12
  * Bumped Standards-Version to 4.3.0
  * Added upstream metadata file
  * debian/copyright: updated URI and packaging copyright years.
  * debian/patches/*: renamed all patches to organize better
  * debian/tests/*: created to provide trivial tests.
  * debian/watch: added a mangle rule to handle the '+git' suffix.

 -- Giovani Augusto Ferreira <giovani@debian.org>  Wed, 09 Jan 2019 00:06:01 -0200

exifprobe (2.0.1+git20170416.3c2b769-2) unstable; urgency=medium

  * Team upload.
  * Integrate the NMU. Thanks Adrian.
  * Bump Standards-Version to 4.2.0.
  * Update team maintainer address to Debian Security Tools
    <team+pkg-security@tracker.debian.org>
  * Update Vcs-Git and Vcs-Browser for the move to salsa.debian.org

 -- Raphaël Hertzog <hertzog@debian.org>  Sat, 25 Aug 2018 12:53:53 +0200

exifprobe (2.0.1+git20170416.3c2b769-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Add upstream fix for segfaults due to missing function prototypes.
    (Closes: #874275)

 -- Adrian Bunk <bunk@debian.org>  Wed, 08 Aug 2018 21:56:31 +0300

exifprobe (2.0.1+git20170416.3c2b769-1) unstable; urgency=medium

  * New upstream release: fixed crashes on corrupt file. (Closes: #809365)
  * Updated my email address.
  * debian/control:
      - Bumped Standards-Version to 4.0.0.
  * debian/copyright: updated the packaging copyright years.
  * debian/patches:
      - fix-issues-found-by-afl.patch: removed, the upstream fixed the
        source code. Thanks.
      - fix-makefile.patch: updated to improve GCC hardening.

 -- Giovani Augusto Ferreira <giovani@debian.org>  Sat, 08 Jul 2017 19:36:23 -0300

exifprobe (2.0.1-11) unstable; urgency=medium

  * Update DH level to 10.
  * debian/compat: updated to 10.

 -- Giovani Augusto Ferreira <giovani@riseup.net>  Fri, 16 Dec 2016 22:52:19 -0200

exifprobe (2.0.1-10) unstable; urgency=medium

  * debian/control:
      - Bumped Standards-Version to 3.9.8.
  * debian/patches:
      - Added the '.patch' extension to all patches.
      - fix-manpages.patch: added a typing error correction for exifprobe.1

 -- Giovani Augusto Ferreira <giovani@riseup.net>  Sat, 24 Sep 2016 19:18:13 -0300

exifprobe (2.0.1-9) unstable; urgency=medium

  * debian/control: Changed from cgit to git in Vcs-Browser field.
  * debian/patches/fix_spelling_error:
       - Added a typing error correction for misc.c.
  * debian/watch: bumped to version 4.

 -- Giovani Augusto Ferreira <giovani@riseup.net>  Sun, 20 Mar 2016 22:30:48 -0300

exifprobe (2.0.1-8) unstable; urgency=medium

  * New upload to try rebuild and fix powerpc.

 -- Giovani Augusto Ferreira <giovani@riseup.net>  Sun, 06 Mar 2016 11:47:47 -0300

exifprobe (2.0.1-7) unstable; urgency=medium

  * New co-maintainer. Thanks Eriberto Mota for great work in the last uploads.
  * debian/control:
      - Bumped Standards-Version to 3.9.7.
      - Updated Vcs-* fields.
  * debian/copyright:
      - Added my name at debian/* block.
      - Dropped dot-zero from GPL license short name.

 -- Giovani Augusto Ferreira <giovani@riseup.net>  Sat, 20 Feb 2016 23:42:09 -0200

=== debian/control ===
Source: exifprobe
Section: graphics
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Giovani Augusto Ferreira <giovani@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 xutils-dev
Standards-Version: 4.5.1
Rules-Requires-Root: binary-targets
Homepage: https://github.com/hfiguiere/exifprobe
Vcs-Browser: https://salsa.debian.org/pkg-security-team/exifprobe
Vcs-Git: https://salsa.debian.org/pkg-security-team/exifprobe.git

Package: exifprobe
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: read metadata from digital pictures
 Exifprobe reads image files produced by digital cameras (including
 several so-called "raw" file formats) and reports the structure of
 the files and the auxiliary data and metadata contained within them.
 .
 In addition to TIFF, JPEG and EXIF, the program understands several
 formats which may contain "raw" camera data, including MRW, CIFF/CRW,
 JP2/JPEG2000, RAF, and X3F, as well as most TIFF-derived "raw" formats,
 including DNG, ORF, CR2, NEF, K25/KDC/DCR and PEF.
 .
 This program is useful in forensics investigations.

=== debian/watch ===
version=4
opts=dversionmangle=s/\+git.*$// \
https://github.com/hfiguiere/exifprobe/releases .*/archive/v?(\d\S+)\.tar\.(?:bz2|gz|xz)

## exifprobe 2.0.1+git20201230.eee65ff

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # Any compiler should do
 CC?=cc
-CFLAGS=-DCOLOR -O -std=c99
+CFLAGS+=-DCOLOR -O -std=c99
 
 # You probably don't need these
 # CFLAGS=-DCOLOR -g -O -Dlint -Wall  -Wno-long-long 
@@ -22,10 +22,10 @@
 #CFLAGS += -DNATIVE_BYTEORDER_BIGENDIAN     # or add to ./byteorder.h
 
 # On Solaris, you may need to use 'gmake', or edit the next line.
-PREFIX ?= /usr/local
-BINDIR=$(PREFIX)/bin
-MANDIR=$(PREFIX)/man/man1
-
+INSTALL = install -d -m 644
+PREFIX ?= $(DESTDIR)/usr
+BINDIR=$(PREFIX)/bin/local
+MANDIR=$(PREFIX)/share/man/man1
 
 INCLUDES=defs.h extern.h misc.h tifftags.h exiftags.h \
 	tiffeptags.h jpegtags.h global.h
@@ -63,18 +63,20 @@
 	@echo 
 
 veclib.o: lib/veclib.c
-	$(CC) -o veclib.o -c $(CFLAGS) lib/veclib.c
+	$(CC) -o veclib.o -c $(CFLAGS) $(LDFLAGS) $(CPPFLAGS) lib/veclib.c
 
 # Need the math library to calculate some APEX things...
 exifprobe: $(OBJS) $(INCLUDES) Makefile
 	./mkcomptime > comptime.c
-	$(CC) -o exifprobe $(CFLAGS) $(OBJS) comptime.c -lm
+	$(CC) -o exifprobe $(CFLAGS) $(LDFLAGS) $(CPPFLAGS) $(OBJS) comptime.c -lm
 
 install: all
-	cp exifprobe $(BINDIR)
-	cp exifgrep $(BINDIR)
-	cp exifprobe.1 $(MANDIR)
-	cp exifgrep.1 $(MANDIR)
+	install -d $(PREFIX)/bin
+	install -d $(PREFIX)/share/man/man1
+	install -c -m 755 exifprobe $(PREFIX)/bin
+	install -c -m 755 exifgrep $(PREFIX)/bin
+	install -c -m 644  exifprobe.1 $(PREFIX)/share/man/man1
+	install -c -m 644  exifgrep.1 $(PREFIX)/share/man/man1
 
 # if you want HTML man pages, pick a target; I prefer man2html
 rman: exifprobe.1 exifgrep.1

=== aux/Makefile ===
all: extract_section dump_section findjpeg

extract_section: extract_section.c
	${CC} -o extract_section extract_section.c

dump_section: dump_section.c
	${CC} -o dump_section dump_section.c

findjpeg: findjpeg.c
	${CC} -o findjpeg findjpeg.c

extract_section: extract_section.c
	${CC} -o extract_section extract_section.c

clean:
	rm -f extract_section dump_section findjpeg

=== debian/changelog ===
exifprobe (2.0.1+git20201230.eee65ff-2) unstable; urgency=medium

  * Team upload.

  * d/p/*:
    - Drop 006-fix-makefile.patch, it sets only unneeded gcc flags.
    - Drop 005-add-byteorder.patch, it supports little endianness only.
    - Add patch for applying the correct HOST endianness during the build.
    - Add patch to move prerequisite byteorder.h to the correct target.
    - Add patch to run autopkgtest on s390x successfully.
  * d/salsa-ci.yml: Add variable SALSA_CI_DISABLE_BUILD_PACKAGE_ALL.

 -- Sven Geuer <sge@debian.org>  Wed, 05 Feb 2025 22:57:56 +0100

exifprobe (2.0.1+git20201230.eee65ff-1) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Update standards version to 4.6.0, no changes needed.
  * Update standards version to 4.6.1, no changes needed.

  [ Sven Geuer ]
  * d/watch: Make it functioning again.
  * New upstream snapshot 2.0.1+git20201230.eee65ff
  * d/p/006-fix-makefile.patch: Adapt patch to new snapshot.
  * d/p/*:
    - Drop patches applied upstream.
    - Add patch to fix type of timestamp variable (Closes: #1089549).
    - Add patch fixing formatting errors in exifgrep manpage.
  * d/control: Bump Standards-Version to 4.7.0.
  * d/copyright: Update the Debian Copyright field.

 -- Sven Geuer <sge@debian.org>  Mon, 03 Feb 2025 00:50:27 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  xutils-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.7.0
 Rules-Requires-Root: binary-targets
 Homepage: https://github.com/hfiguiere/exifprobe
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/exifprobe

=== debian/watch ===
version=4
opts=\
	mode=git,\
	gitmode=full,\
	pretty=2.0.1+git%cd.%h \
https://github.com/hfiguiere/exifprobe.git \
HEAD
